#include "stdafx.h"
#define MAXNAMELN 31
#define MAXBONES 76
#define MAXFRAMES 312


/////////////////////////////////
// legacy, built for testing output, don't use this
void coutBits(unsigned char L1)
{
	int i;
	bool tmpBits[9] = {0};
	unsigned char L2 = 128; // 1000 0000 (first bit)
	for(i=1;i <= 8; i++)
	{
		if( (L1 & L2) == L2) // if this bit is one then output 1
			tmpBits[i] = 1;

		L2 >>= 1; //Shift the bits left, for further comparison
	}
	
	for(i=1;i <= 8; i++)
		cout << (short)tmpBits[i];

}


// This function is for reading a single bit from an 8-bit value (byte)
			// Input value (8-bits) //	Bit number from the left 1<--->8
bool getbit(unsigned char L1, unsigned char inx)
{
	unsigned char L2 = 128; // 1000 0000 (first bit)

	L2 >>= (inx-1); // bit shift left
	if( (L1 & L2) == L2) // check for a result match
		return 1;
	else
		return 0;

}
// This function is for reading a single bit from an 8-bit value (byte)
			// Input value (16-bits) //	Bit number from the left 1<--->8
bool getbit16(unsigned short L1, unsigned char inx)
{
	unsigned short L2 = 32768; // 1000 0000  0000 0000(first bit)

	L2 >>= (inx-1); // bit shift left
	if( (L1 & L2) == L2) // check for a result match
		return 1;
	else
		return 0;

}
	// bytes (8bits)
unsigned char bits2byte(bool b1, bool b2, bool b3, bool b4, bool b5, bool b6, bool b7, bool b8)
{
	return (b1*128 + b2*64 + b3*32 + b4*16 + b5*8 + b6*4 + b7*2 + b8);
}

float genExponent(short base, short pow) // base 2
{
	short i;
	float value= (float)base;
	if(pow >= 2)
		for(i=2;i <= pow;i++)
			value = value * base;
	else if(pow < 0)
	{
		for(i=2;i <= -pow;i++)
			value = value * base;
		value = (float)1.0/value;
	}
	else if(pow = 0)
		value = 1;
	return value;
}
float conv16flt_32flt(unsigned short inputData, char place) //, unsigned char precision)
{
	float finalFloat = 0;
	char k;
	// Mantissa
	for(k = 2; k <= 16; k++)
	{
		finalFloat+= (genExponent(2,place))*getbit16(inputData,k);
		place --;
	}
	if( getbit16(inputData,1) == 1)
		finalFloat = (finalFloat-1);
	return finalFloat;
}


////////////////////

class trifloat
{
public:
	float x;
	float y;
	float z;
};

class quadfloat
{
public:
	float x;
	float y;
	float z;
	float w;
};

class bones
{
public:
	char name[MAXNAMELN];
//	quadfloat quat[MAXFRAMES];
//	trifloat pos[MAXFRAMES];
};

int main(int argc, char* argv[]) //argc is number of commands including program name
{
//	char fileInName[255], fileOutName[255];
	if(argc <= 1)
	{
		cout << "***ERROR***  Please supply a file name:\n\t Useage:  program.exe filename.baf\n\n";
		return 0;
	}

	ifstream fin(argv[1], ios::in | ios::binary | ios::nocreate);

//	fstream fout("output_file.maf",ios::out | ios::binary | ios::trunc);

	long header, currentframe,numFramesTotal, i,n,j;
	short place = 0;
	unsigned short numBones,numData,datalen,tmps;
	unsigned char precision;
	
//**HEADER
	fin.read((char*)&header,4);
	fin.read((char*)&numBones,2);
	cout << "File: " << argv[1] << endl
		 << "(.baf)header: " << header << endl
		 << "----------------" <<  endl;

	cout << numBones;
	cout << "\t// number of bones" << endl;

	if(header != 3)
	{
		cout << "***ERROR***  Header != 0 __ " << (long)header << endl;
		return 0;
	}
	
	unsigned short txtLen;
	bones bone[MAXBONES];

	for(i=1;i <= numBones; i++)
	{
		fin.read((char*)&txtLen,2);
		if(txtLen > MAXNAMELN)
		{
			cout << "***ERROR***  name lenght > " << MAXNAMELN << endl;
			break;
		}
		fin.read((char*)&bone[i].name,txtLen);
		cout << bone[i].name << endl ;
	}

	fin.read((char*)&numFramesTotal,4);
	fin.get(precision); // precision of position 16-bit floats
	
	cout  << numFramesTotal;
	cout << "\t// number of frames" << endl;
	cout << short(precision);
	cout << "\t// precision (number of bits in matissa)" << endl;

	for(n=1;n <= numBones;n++) // for each bone
	{
		fin.read((char*)&numData,2);
		for(j=1; j <= 7; j++)
		{
			fin.read((char*)&datalen,2);
		//	cout << "  dataleft: " << dataleft << endl;		
		//	cout << datalen;
			cout << "\t// component: " << j << "  Bone: " << n << endl;
			currentframe = 1;
			while(currentframe <= numFramesTotal)
			{
//// start datapart header
				fin.read((char*)&tmps,2);

	/*			// display the bits
				for(k=1; k <= 8; k++)
					cout << getbit16(tmps,(char)k);
				cout << ' ';
				for(k=9; k <= 16; k++)
					cout << getbit16(tmps,(char)k);
*/
				bool htype=0;
				unsigned char nframes=0,nHeader=0;

				//Header
				htype = getbit16(tmps,9);
				nframes = bits2byte(0,
					getbit16(tmps,10),
					getbit16(tmps,11),
					getbit16(tmps,12),
					getbit16(tmps,13),
					getbit16(tmps,14),
					getbit16(tmps,15),
					getbit16(tmps,16));
				nHeader = bits2byte(getbit16(tmps,1),
					getbit16(tmps,2),
					getbit16(tmps,3),
					getbit16(tmps,4),
					getbit16(tmps,5),
					getbit16(tmps,6),
					getbit16(tmps,7),
					getbit16(tmps,8));
		/*		cout << " nFrames: " << (short)nframes << ' '
					 << " nextHeader: " << (short)nHeader << ' '
					 << " hType: " << (short)htype << ' ';
				cout << endl;
		*/
///////////// end datapart header			
				if(htype == 0) // raw data
				{
					for(i=1; i <= nframes; i++)
					{
						fin.read((char*)&tmps,2);
					//	cout << "fr_" << currentframe << "\t";
						cout << conv16flt_32flt(tmps,-1) << endl;
						currentframe++;
					}
				}
				else // rle
				{
					fin.read((char*)&tmps,2);				
					float tmppfloat;
					tmppfloat = conv16flt_32flt(tmps,-1);
					for(i=1; i <= nframes; i++)
					{		
					//	cout << "fr_" << currentframe << "\t";
						cout << tmppfloat << endl;
						currentframe++;
					}

				}
			}
		}	
	//	cout << "\n\n/\\/\\Debug fin.tellg() = " << fin.tellg() << endl;
	}

	fin.close();	
//	fout.close();

	cout << endl << endl;
	return 0;
}

