// IOIO.cpp : Defines the entry point for the console application.
// SKINS .skn

#include "stdafx.h"
#define MAXNAMELN 128
#define MAXBONES 2048


class trifloat
{
public:
	float x;
	float y;
	float z;
};


class bones
{
public:
	char name[MAXNAMELN];
	float unknown1;
	char flag[3];
	char flagA;
	char flagB;
	char flagC;
	trifloat vertex[3];
	
};

int main(int argc, char* argv[]) //argc is number of commands including program name
{
//	char fileInName[255], fileOutName[255];

	if(argc <= 1)
	{
		cout << "***ERROR***  Please supply a file name:\n\t Useage:  program.exe filename.skn\n\n";
		return 0;
	}

	ifstream fin(argv[1], ios::in | ios::binary | ios::nocreate);


//	fstream fout("output_file.txt",ios::out | ios::in | ios::binary | ios::trunc);

	long header1, numX, i,j;
	unsigned short numB, txtLn;
	
//**HEADER
	fin.read((char*)&header1,4);
	fin.read((char*)&numX,4);
	cout << "(.skn)header1: " << header1 << endl
		 << "NumberOf Verticies: " << numX << endl
		 << "----------------" << endl <<endl;
	if(header1 != 1)
	{
		cout << "***ERROR***  Header != 1 __ " << (long)header1 << endl;
		return 0;
	}
	

	bones bone[MAXBONES];

	for(i=1;i <= numX; i++)
	{
		cout << "*Reading Vertex #: " << i << endl <<"___________________" << endl;

		fin.read((char*)&bone[i].vertex[1].x ,4);
		fin.read((char*)&bone[i].vertex[1].y ,4);
		fin.read((char*)&bone[i].vertex[1].z ,4);
		cout << " Vertex Pos_X: " << bone[i].vertex[1].x << endl
			 << " Vertex Pos_Y: " << bone[i].vertex[1].z << endl
			 << " Vertex Pos_Z: " << bone[i].vertex[1].y << endl;

		fin.get( bone[i].flagA );
		fin.get( bone[i].flagB );
		fin.get( bone[i].flagC );
		cout  << "\t" << "flagA:           " << (short)bone[i].flagA << endl;
		cout  << "\t" << "Belongs to bone: " << (short)bone[i].flagB << endl;
		cout  << "\t" << "flagC:           " << (short)bone[i].flagC << endl;

		fin.read((char*)&bone[i].unknown1 ,4);
		cout << "   Weight: " << bone[i].unknown1 << endl;

		fin.read((char*)&bone[i].vertex[2].x ,4);
		fin.read((char*)&bone[i].vertex[2].y ,4);
		fin.read((char*)&bone[i].vertex[2].z ,4);

		cout << "  Envelope_X: " << bone[i].vertex[2].x << endl
			 << "  Envelope_Y: " << bone[i].vertex[2].z << endl
			 << "  Envelope_Z: " << bone[i].vertex[2].y << endl;

		if(bone[i].unknown1 == 1)
		{
			// nothing done cause it's 1
		}
		else if(bone[i].unknown1 == 0.5)
		{
			for(j=1;j <= 2; j++)
				fin.get( bone[i].flag[j] );

			for(j=1;j <= 2; j++)
				cout  << "\t" << j << "_EX flag(0.5): " << (short)bone[i].flag[j] << endl;

			fin.read((char*)&bone[i].unknown1 ,4);
						cout << "   Weight: " << bone[i].unknown1 << "\t// Scale, weight or something" << endl;
			fin.read((char*)&bone[i].vertex[3].x ,4);
			fin.read((char*)&bone[i].vertex[3].y ,4);
			fin.read((char*)&bone[i].vertex[3].z ,4);


			cout << " C_Float: " << bone[i].vertex[3].x << endl
			 << " C_Float: " << bone[i].vertex[3].y << endl
			 << " C_Float: " << bone[i].vertex[3].z << endl;


		}
		else
		{
			cout << "***ERROR*** ?_float (unknown1) = " << bone[i].unknown1 << endl;
			fin.close();
			return 0;
		}

	cout << endl;
		

	//	cout << "\n\n/\\/\\Debug fin.tellg() = " << fin.tellg() << endl;
	}


	fin.read((char*)&numB ,2);
	cout << "\n================\n"
		<< " Number of Names: " << numB 
		<< "\n================\n";

	for(i=1;i <= numB; i++)
	{
		fin.read((char*)&txtLn ,2);

		fin.read((char*)&bone[i].name ,txtLn);
		cout << "Text_" << i << " :\t" << bone[i].name << endl;
	}
	
 

	



	fin.close();	
//	fout.close();

	cout << endl << endl;
	return 0;
}

